/*  ***** BEGIN LICENSE BLOCK *****
 *  Version: RPPL 1.0/GPL 2.0/LGPL 2.1/MPL 1.1/CDDL 1.0
 *  
 *  
 *  The contents of this file are subject to the Roland Pihlakas Public
 *  License Version 1.0 (the "License"); you may not use this file except
 *  in compliance with the License. You may obtain a copy of the License
 *  at http://roland.pri.ee/RPPL/
 *  
 *  Software distributed under the License is distributed on an "AS IS"
 *  basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 *  License for the specific language governing rights and limitations
 *  under the License.
 *  
 *  The Original Code is: Modelling of Natural Thinking.
 *  
 *  The Initial Developer of the Original Code is: Roland Pihlakas.
 *  
 *  Portions created by: _____________________________ 
 *  are Copyright (C): _____________________________. 
 *  All Rights Reserved.
 *  Contributor(s): ______________________________________.
 *  
 *  Alternatively, the contents of this file may be used under the terms of 
 *  either the GNU General Public License Version 2 or later (the "GPL"), or 
 *  the GNU Lesser General Public License Version 2.1 or later (the "LGPL"), or 
 *  the Mozilla Public Licence Version 1.1 or later (the "MPL"), or the Common 
 *  Development and Distribution License Version 1.0 or later (the "CDDL"), in 
 *  which case the provisions of the MPL, the GPL, the LGPL or the CDDL are 
 *  applicable instead of those above. If you wish to allow use of your version 
 *  of this file only under the terms of the of either the MPL, the GPL, 
 *  the LGPL or the CDDL, and not to allow others to use your version of this 
 *  file under the RPPL, indicate your decision by deleting the provisions 
 *  above and replace them with the notice and other provisions required by 
 *  the MPL, the GPL, the LGPL or the CDDL. If you do not delete the provisions 
 *  above, a recipient may use your version of this file under the terms of any 
 *  one of the RPPL, the MPL, the GPL, the LGPL or the CDDL.
 *
 *  ***** END LICENSE BLOCK ***** */

//######################################################################################################
//
//######################################################################################################



#ifndef TA_CLASS_DEFINED
#define TA_CLASS_DEFINED



#include "tasand1/signalling_and_parameter.h"




#pragma optimize ("gt", on)		  ///Enable global optimizations. Specify fast sequences of machine code.



namespace type_array
{

	using namespace sse_vector;



	//TODO: see http://www.boost.org/libs/multi_array/doc/user.html
	

	
	//namespace definitions {		 ///necessary for BOOST_TYPEOF_REGISTER_TEMPLATE
	
	template
	<
		definitions::ssize_t num_dimensions,
		typename value_T,
		definitions::ssize_t alignment = 0
	>
	class NT_A;
	
	template
	<
		definitions::ssize_t num_dimensions1,
		definitions::ssize_t num_dimensions2,
		typename value_T,
		definitions::ssize_t alignment1 = 0,
		definitions::ssize_t alignment2 = alignment1
	>
	class T_M;
	
	template
	<
		definitions::ssize_t num_dimensions,
		definitions::ssize_t alignment = 0
	>
	class AA;
	
	///#######################################################################
	///
	///#######################################################################

	#include "type_array_iterators.h"
	
	
	///#######################################################################

	#include "type_array_base.h"
		
	///#######################################################################
	///
	///#######################################################################
	
	#include "type_array_OTA.h"

	///#######################################################################
	///
	///#######################################################################

	#include "type_array_NTA.h"
	#include "type_array_float_TA.h"
	 	
	///#######################################################################
	///
	///#######################################################################
	
}	


#include <boost/type_traits/is_fundamental.hpp>
#include <boost/type_traits/is_pointer.hpp>


namespace type_array
{
	
	
	#include "type_array_derivations.h"
	
	
	///#######################################################################
	///
	///#######################################################################
	
	
	#include "numeric_type_wrapper.h"
	
	
///#######################################################################
///
///#######################################################################

	#include "type_pointer.h"
	
///#######################################################################
///
///#######################################################################
	
	
}		///namespace type_array	
	





	
	
#pragma optimize ("", on)			///When you use the on parameter, it resets the optimizations to those that you specified with the /O compiler option.
	
	
	
	
///#######################################################################
///
///#######################################################################

#endif		///#ifndef TA_CLASS_DEFINED





