



#include "tasandid_stdafx.h"			 

#pragma hdrstop //("echo_lines_pch.pch")		///necessary for performance analyzer to compiler, when MAX_NONLINEAR_ASSOC_CELL_POINTS	has different values in different files




#include <conio.h>										///must be included before curses.h




#define NOMACROS
#define INCLUDE_WINDOWS_H
#include "D:\SimRobotXP\pdcurses\curses.h"
#undef NOMACROS



												   
#define __ECHO_LINES_TEST_CPP__	
										///for nonlinear_assoc_cell class stats counters instantiation 
										
/*										
#define ENABLE_OUTPUT_OUTPUT_PREDICTIONS				0
#define MAX_NONLINEAR_ASSOC_CELL_POINTS					5	//16
	#define NONLINEAR_ASSOC_CELL_SAVE_LAST_IO_VAL			0		//1		//0
#define DISABLE_NULL_INPUT_VALUE_PREDICTIONS			0				///lets enable them for nonlinear assoc cells!
#define USE_REAL_VALUES									1
#define USE_NEGDIFF_POSDIFF_ECHOLINE_DIFFERENTIATION	0				///no need to differentiate if we meet these criteria: we dont use value_diffs and we do use nonlinear assoc cells
#define USE_ADDITIVE_PREDICTIONS						1
#define ENABLE_INPUT_OUTPUT_PREDICTIONS					1
#define SOM_USE_RANDOM_INITIAL_STATE					1		//1			//NB!



#define MAX_PIPELINE_LEVEL			13
#define PIPELINE_MAX_ELEM_PARAMS	6
#define MAX_INHERITANCE_LEVEL		8

*/




//#define NET_DECLARE_ONLY



///#######################################################################
///
///#######################################################################

namespace ai
{
  
	template 
	<
		typename pipelines_collection_T
	>
	class timelines_testcode_net : public pipelines_collection_T
	{
	
	public:
	
		typedef pipelines_collection_T	parent_net_T;
		
	

	public:

		virtual void init()
		{
			parent_net_T::init();
		
			/*
			inputs = new inputs__T();
			inputs->init();
			
			outputs = new outputs__T();
			outputs->init();
			*/
		
			inputs->set_num_items(1);			    
			outputs->set_num_items(10);
		};	
		
	///#######################################################################
	
		/*		
		virtual void deinit()
		{
			
			inputs->deinit();
			delete inputs;
			
			outputs->deinit();			
			delete outputs;
			
			
			parent_net_T::deinit();			
		};		
		*/
		
	///#######################################################################
		
		void set_input(int val)
		{
			inputs->get_item_atindex(0)->set(val);
		};			

	///#######################################################################
		
		void set_output(int val)
		{
			outputs->get_item_atindex(0)->set(val);
		};			

	///#######################################################################
		
		int get_output()
		{
			outputs->get_item_atindex(0)->get();
		};			

	///#######################################################################
		
		void cycle(bool learn = true)
		{
			inputs->tick_lines();
			//outputs->tick_lines();
			inputs->calc_predictions();
			
			
			if (learn)
			{
				//outputs->close_prediction_cycles();
				inputs->prepare_for_corr_updates();
				inputs->update_corrs();
			}
			
				
			//inputs->prepare_for_next_cycle();
		};

	///#######################################################################

		void prepare_for_next_cycle()
		{
			inputs->nextcycle();
			outputs->nextcycle();
		};


	};

}


///#######################################################################
///
///#######################################################################


#include "..\tasand1_echo_lines\echo_lines.h"
///#include "../tasand2/pattern_cell.h"		 


///#######################################################################
///
///#######################################################################


///#include <iostream>
///#include <fstream>
///#include <ios>	



using namespace std;
///using namespace std::ios;	
using namespace ai;
using namespace curses;

namespace fs = boost::filesystem;	  
	
///#######################################################################
///
///#######################################################################
	
curses::WINDOW *win = NULL;

#define COLOR_GRAY			8
#define COLOR_BRIGHTBLUE	9
#define COLOR_BIRGHTGREEN	10
#define COLOR_BRIGHTCYAN	11
#define COLOR_BRIGHTRED		12
#define COLOR_BRIGHTMAGENA	13
#define COLOR_BRIGHTYELLOW	14
#define COLOR_BRIGHTWHITE	15 


	
	
const S max_line_len = 100;
	
T_M<100, max_line_len, S> input_samples;
T_M<100, max_line_len, S> output_samples;
	
	
///#######################################################################
///
///#######################################################################
		
bool readline(std::ifstream &is, S &data_type, S &inner_index, T_A<max_line_len, S> &datapoints)
{
	//char byte;
	string line_str;
	
	
	do
	{
		getline(is, line_str, is.widen('\n'));
		
		if (is.rdstate() & ios::failbit)
			return false;			///EOF reached
	}
	while (line_str.length() < 4);						///skip empty lines
	
	
	//line << line_str;	
	stringstream line(line_str);
	
	
	line >> data_type;
	line >> inner_index;
	
	
	datapoints.reset();
	S i = 0;
	while (!(line.rdstate() & ios::eofbit))
	{
		line >> datapoints[i];
		i++;
	}
	
	for (; i < max_line_len; i++)
	{
		datapoints[i] = -1;
	}
	

	return true;
}
	
///#######################################################################
///
///#######################################################################
	
void readfile(const char *filename)
{
	input_samples.reset();
	output_samples.reset();


	fs::path p(filename, fs::native);
	//boost::intmax_t infilesize = fs::file_size(p);
	
	std::ifstream is;
	is.open(filename, std::ios_base::in | std::ios::binary);
		
	
	S series_index = 0;
	
	do
	{	
		S data_type;
		S inner_index;
		T_A<max_line_len, S> datapoints1;
		T_A<max_line_len, S> datapoints2;
		
		bool firstline_success = readline(is, data_type, inner_index, datapoints1);
		if (!firstline_success)
			break;
			
		input_samples[inner_index] = datapoints1;

			
		if (data_type == 1)		///training data
		{
			bool secondline_success = readline(is, data_type, inner_index, datapoints2);
			if (!secondline_success)
			{
				break;
			}
		}
		
		output_samples[inner_index] = datapoints2;
		
		series_index++;
	}
	DISABLE_WARNING(4127)	///warning C4127: conditional expression is constant
	while (1);
	END_DISABLE_WARNING
		
		
	is.close();
}

///#######################################################################
///
///#######################################################################

bool training_skipped = false;

template <typename net_T>
void set_inputs_from_datapoints(net_T *net, S inputs_line_index, bool train)
{
	S i;

	T_A<max_line_len, S> &input_line = input_samples[inputs_line_index];
	T_A<max_line_len, S> &output_line = output_samples[inputs_line_index];
	
	training_skipped = false;
	
	
	for (i = 0; i < max_line_len;  i++)
	{
		S ival = input_line[i];
		
		if (ival == -1)
			break;
	
		net->set_input(ival);
		
		if (train)
		{
			S oval = output_line[i];
			if (oval == -1)
				training_skipped = true;
			else
				net->set_output(oval);
			
		}
		
		net->cycle(!training_skipped && train);	
		//net->get_outputs(...);
		net->prepare_for_next_cycle();	
	}
}

///#######################################################################
///
///#######################################################################

void status(const char *str)
{
	mvwaddstr(win, 3, 3, "                                                                          ");	 ///clear line, 74 chars long
	mvwaddstr(win, 3, 3, str);
}
										    
///#######################################################################
///
///#######################################################################

int __cdecl main()
{
	initscr();
	
#ifdef A_COLOR
	if (has_colors())
		start_color();
#endif

	int width = 319;	
	int height = 130;
	
	int res = resize_term(height, width);		///lets try max resolution at first
	win = newwin(height, width, 0, 0);


#ifdef A_COLOR
	if (has_colors())
	{
		init_pair(1, COLOR_BRIGHTWHITE, COLOR_BLACK);
		init_pair(2, COLOR_BRIGHTYELLOW, COLOR_BLACK);			
		init_pair(3, COLOR_BRIGHTCYAN, COLOR_BLACK);			

		init_pair(5, COLOR_BRIGHTWHITE, COLOR_BLUE);
		init_pair(6, COLOR_BRIGHTYELLOW, COLOR_BLUE);			
		init_pair(7, COLOR_BRIGHTCYAN, COLOR_BLUE);			


		wbkgd(win, COLOR_PAIR(1));
	}
	else
#endif
		wbkgd(win, A_REVERSE);

	erase();
	werase(win);
	wrefresh(win);


	///#######################################################################


	char *filename = "timelines.txt";
	
	readfile(filename);
	
	
	//assoc_net_1_with_timelines_classical_testcode5		*net = new assoc_net_1_with_timelines_classical_testcode5();
	NEWOBJ(net, assoc_net_1_with_timelines_classical_testcode5)();
	net->init();
	


	char buf[128];
	int line_index;
	char *str;
	

	bool exit = false;
	do
	{
		int ch = getch();
		
		switch(ch)
		{
			case 'e':
				status("exit");
				exit = true;
				break;		
		
		
			case 'l':
				status("load");
				net->deinit();
				net->init();
				readfile(filename);
				break;
				
				
			case 't':
				status("insert line index to train");				
				buf[0] = 124;		   /// Maximum characters in 1st byte		
				str = _cgets(buf);		   ///_cgets and _cgetws return a pointer to the start of the string, at buffer[2]
				line_index = atol(str);
								
				set_inputs_from_datapoints(net, line_index, true);
				
				if (training_skipped)
					status("some or all of training output points were missing");
				else
					status("training done");	
		
				break;
			
			
			case 'p':
				status("insert line index to send to inputs");				
				buf[0] = 124;		   /// Maximum characters in 1st byte		
				str = _cgets(buf);		   ///_cgets and _cgetws return a pointer to the start of the string, at buffer[2]
				line_index = atol(str);
								
				set_inputs_from_datapoints(net, line_index, false);
				
				status("inputs cycled ok");
				
				break;
						
		
			default:;
				///do nothing
		};	
	}
	while (!exit);

	
	net->deinit();
	delete net;

}

///#######################################################################
///
///#######################################################################
